---

 source/interpret.c |  120 ++++++++++++++++++++++++++++-------------------------
 1 file changed, 64 insertions(+), 56 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -189,31 +189,39 @@ static int (*OpFns[])() = {
 };
 
 /* Stack-> symN-sym0(FP), nArgs, oldFP, retPC, argArray, argN-arg1, next, ... */
-#define FP_ARG_COUNT_INDEX (-1)
-#define FP_FUNCTION_NAME   (-2) /* !! */
-#define FP_SYMBOL_TABLE    (-3) /* !! */
-#define FP_LOOP_CNT        (-4)
-#define FP_OLD_LOOP_PTR    (-5)
-#define FP_OLD_FP_INDEX    (-6)
-#define FP_RET_PC_INDEX    (-7)
-#define FP_PROG_INDEX      (-8)
-#define FP_ARG_ARRAY_INDEX (-9)
-
-#define FP_TO_ARGS_DIST (0 - FP_ARG_ARRAY_INDEX) /* should be 0 - (above index) */
-
-#define FP_GET_ITEM(xFrameP,xIndex) (*(xFrameP + xIndex))
-#define FP_GET_ARG_ARRAY(xFrameP) (FP_GET_ITEM(xFrameP, FP_ARG_ARRAY_INDEX))
-#define FP_GET_ARG_COUNT(xFrameP) (FP_GET_ITEM(xFrameP, FP_ARG_COUNT_INDEX).val.n)
-#define FP_GET_OLD_FP(xFrameP) ((FP_GET_ITEM(xFrameP, FP_OLD_FP_INDEX)).val.dataval)
-#define FP_GET_RET_PC(xFrameP) ((FP_GET_ITEM(xFrameP, FP_RET_PC_INDEX)).val.inst)
-#define FP_GET_PROG(xFrameP) ((FP_GET_ITEM(xFrameP, FP_PROG_INDEX)).val.prog)
-#define FP_GET_FUNCTION_NAME(xFrameP) ((FP_GET_ITEM(xFrameP, FP_FUNCTION_NAME)).val.str)
-#define FP_ARG_START_INDEX(xFrameP) (-(FP_GET_ARG_COUNT(xFrameP) + FP_TO_ARGS_DIST))
-#define FP_GET_ARG_N(xFrameP,xN) (FP_GET_ITEM(xFrameP, xN + FP_ARG_START_INDEX(xFrameP)))
-#define FP_GET_SYM_TAB(xFrameP) (FP_GET_ITEM(xFrameP, FP_SYMBOL_TABLE).val.sym)
-#define LocalSymList FP_GET_SYM_TAB(Interpreter->frameP)
-#define FP_GET_OLD_LOOP_PTR(xFrameP) (FP_GET_ITEM(xFrameP, FP_OLD_LOOP_PTR).val.instp)
-#define FP_GET_LOOP_CNT(xFrameP) (FP_GET_ITEM(xFrameP, FP_LOOP_CNT).val.n)
+enum {
+    FP_BASE = 0,    /* first element of current frame, not used */
+    FP_ARG_COUNT,   /* nArgs */
+    FP_NAME,        /* function name */
+    FP_LOCAL_SYMS,  /* local symbol list */
+    FP_LOOP_CNT,    /* loop counter */
+    FP_OLD_LP,      /* old loop pointer */
+    FP_OLD_FP,      /* old frame pointer */
+    FP_RET_PC,      /* return PC */
+    FP_PROG,        /* the program  */
+    FP_ARG_ARRAY,   /* argument array */
+    FP_LAST_ARG     /* last arg, i.e. argN, used for FP_DIST_TO_ARGS */
+};
+#define FP_DIST_TO_ARGS (FP_LAST_ARG - 1)
+
+#define FP_GET(xFrameP, xIndex)     (*((xFrameP) - (xIndex)))
+
+/* arguments */
+#define FP_ARG1_INDEX(xFrameP)      (FP_GET_ARG_COUNT(xFrameP) + FP_DIST_TO_ARGS)
+/* zero based */
+#define FP_GET_ARG_N(xFrameP, xN)   (FP_GET(xFrameP, FP_ARG1_INDEX(xFrameP) - (xN)))
+
+#define FP_GET_ARG_ARRAY(xFrameP)   (FP_GET(xFrameP, FP_ARG_ARRAY))
+#define FP_GET_PROG(xFrameP)        (FP_GET(xFrameP, FP_PROG).val.prog)
+#define FP_GET_RET_PC(xFrameP)      (FP_GET(xFrameP, FP_RET_PC).val.inst)
+#define FP_GET_OLD_FP(xFrameP)      (FP_GET(xFrameP, FP_OLD_FP).val.dataval)
+#define FP_GET_OLD_LP(xFrameP)      (FP_GET(xFrameP, FP_OLD_LP).val.instp)
+#define FP_GET_LOOP_CNT(xFrameP)    (FP_GET(xFrameP, FP_LOOP_CNT).val.n)
+#define FP_GET_LOCAL_SYMS(xFrameP)  (FP_GET(xFrameP, FP_LOCAL_SYMS).val.sym)
+#define FP_GET_NAME(xFrameP)        (FP_GET(xFrameP, FP_NAME).val.str)
+#define FP_GET_ARG_COUNT(xFrameP)   (FP_GET(xFrameP, FP_ARG_COUNT).val.n)
+
+#define LocalSymList FP_GET_LOCAL_SYMS(Interpreter->frameP)
 #define LoopStackCnt FP_GET_LOOP_CNT(Interpreter->frameP)
 
 /*
@@ -548,12 +556,12 @@ static int setupNestedFrame(RestartData 
     int nArgs = FP_GET_ARG_COUNT(context->frameP);
     DataValue *args = &FP_GET_ARG_N(context->frameP, 0);
     DataValue argArray = FP_GET_ARG_ARRAY(context->frameP);
-    Symbol *symList = FP_GET_SYM_TAB(context->frameP);
+    Symbol *symList = FP_GET_LOCAL_SYMS(context->frameP);
 
     ret = setupFrame(context, prog, nArgs, args, argArray, prog->name);
 
     if (ret == STAT_OK) {
-        FP_GET_SYM_TAB(context->frameP) = symList;
+        FP_GET_LOCAL_SYMS(context->frameP) = symList;
     }
 
     return STAT_OK;
@@ -566,7 +574,7 @@ static void rewindFrame(RestartData *con
     DataValue *newFrameP = FP_GET_OLD_FP(context->frameP);
     Inst *newPC = FP_GET_RET_PC(context->frameP);
     Program *prog = FP_GET_PROG(context->frameP);
-    Symbol *symList = FP_GET_SYM_TAB(context->frameP);
+    Symbol *symList = FP_GET_LOCAL_SYMS(context->frameP);
     int isNestedFrame = prog->nested;
 
     /* pop remaining vars on the stack and free any array iterators */
@@ -579,10 +587,10 @@ static void rewindFrame(RestartData *con
     }
 
     /* pop past arguments */
-    context->stackP -= (FP_TO_ARGS_DIST + nArgs);
+    context->stackP -= (FP_DIST_TO_ARGS + nArgs);
 
     /* restore loop stack pointer */
-    context->loopStackPtr = FP_GET_OLD_LOOP_PTR(context->frameP);
+    context->loopStackPtr = FP_GET_OLD_LP(context->frameP);
 
     context->frameP = newFrameP;
 
@@ -595,7 +603,7 @@ static void rewindFrame(RestartData *con
     }
     else {
         /* copy the local symlist back to this frame */
-        FP_GET_SYM_TAB(context->frameP) = symList;
+        FP_GET_LOCAL_SYMS(context->frameP) = symList;
     }
 }
 
@@ -1514,7 +1522,7 @@ static int pushSymVal(void)
             }
             else if (argNum == MACRO_NAME_ARG_VAR) {
                 symVal.tag = STRING_TAG;
-                symVal.val.str = FP_GET_FUNCTION_NAME(FrameP);
+                symVal.val.str = FP_GET_NAME(FrameP);
             }
             else {
                 symVal = FP_GET_ARG_N(FrameP, argNum);
@@ -3028,7 +3036,7 @@ static int returnValOrNone(int valOnStac
     static DataValue noValue = {NO_TAG, {0}};
     
     DISASM_RT();
-    STACKDUMP(StackP - FrameP + FP_GET_ARG_COUNT(FrameP) + FP_TO_ARGS_DIST, 3);
+    STACKDUMP(StackP - FrameP + FP_GET_ARG_COUNT(FrameP) + FP_DIST_TO_ARGS, 3);
 
     /* return value is on the stack */
     if (valOnStack) {
@@ -4424,7 +4432,7 @@ static char *stackDumpStr(RestartData *c
     nFrames = 0;
     do {
         nFrames++;
-        len = len + FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.len + 1;
+        len = len + FP_GET_NAME(nfp).len + 1;
         pc = FP_GET_RET_PC(nfp);
         nfp = FP_GET_OLD_FP(nfp);
     } while (pc);
@@ -4462,7 +4470,7 @@ static char *stackDumpStr(RestartData *c
         while (thisFrameWidth++ < frameWidth)
             *np++ = ' ';
         *np++ = ' ';
-        op = FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.rep;
+        op = FP_GET_NAME(nfp).rep;
         while (*op)
             *np++ = *op++;
         pc = FP_GET_RET_PC(nfp);
@@ -5034,14 +5042,14 @@ static void stackdumpframe(DataValue *ar
     Inst *retPC = FP_GET_RET_PC(fp);
     DataValue *oldFP = retPC ? FP_GET_OLD_FP(fp) : NULL;
     DataValue *arg1 = &FP_GET_ARG_N(fp, 0);
-    DataValue *argc = &FP_GET_ITEM(fp, FP_ARG_COUNT_INDEX);
-    DataValue *fnNm = &FP_GET_ITEM(fp, FP_FUNCTION_NAME);
-    DataValue *prFP = &FP_GET_ITEM(fp, FP_PROG_INDEX);
-    DataValue *ofFP = &FP_GET_ITEM(fp, FP_OLD_FP_INDEX);
-    DataValue *rpFP = &FP_GET_ITEM(fp, FP_RET_PC_INDEX);
-    DataValue *lsFP = &FP_GET_ITEM(fp, FP_SYMBOL_TABLE);
-    DataValue *lcFP = &FP_GET_ITEM(fp, FP_LOOP_CNT);
-    DataValue *olFP = &FP_GET_ITEM(fp, FP_OLD_LOOP_PTR);
+    DataValue *argc = &FP_GET(fp, FP_ARG_COUNT);
+    DataValue *fnNm = &FP_GET(fp, FP_NAME);
+    DataValue *prFP = &FP_GET(fp, FP_PROG);
+    DataValue *ofFP = &FP_GET(fp, FP_OLD_FP);
+    DataValue *rpFP = &FP_GET(fp, FP_RET_PC);
+    DataValue *lsFP = &FP_GET(fp, FP_LOCAL_SYMS);
+    DataValue *lcFP = &FP_GET(fp, FP_LOOP_CNT);
+    DataValue *olFP = &FP_GET(fp, FP_OLD_LP);
     DataValue *dv;
     DataValue *endDv = (arg1 > outpt) ? arg1 : outpt;
     int nArgs = FP_GET_ARG_COUNT(fp);
@@ -5067,27 +5075,27 @@ static void stackdumpframe(DataValue *ar
 
         char *pos = "";
         char buffer[sizeof(STACK_DUMP_ARG_PREFIX) + TYPE_INT_STR_SIZE(int)];
-        int offset = dv - fp;
+        int offset = fp - dv;
         const char *leadIn = (dv >= arrow) ? ">>>>>" :
                              (dv ==  arg1) ? "---->" :
                              (dv ==  argc) ? "====>" : "";
         printd("%5.5s%10p%c", leadIn, dv, topMark);
         switch (offset) {
-            case FP_ARG_COUNT_INDEX: pos = "NArgs";  break; /* num. arguments */
-            case FP_FUNCTION_NAME:   pos = "FnName"; break;
-            case FP_SYMBOL_TABLE:    pos = "FnSyms"; break;
-            case FP_LOOP_CNT:        pos = "LoopCnt";break;
-            case FP_OLD_LOOP_PTR:    pos = "OldLP";  break;
-            case FP_OLD_FP_INDEX:    pos = "OldFP";  break;
-            case FP_RET_PC_INDEX:    pos = "RetPC";  break;
-            case FP_PROG_INDEX:      pos = "Prog";   break;
-            case FP_ARG_ARRAY_INDEX: pos = "args[]"; break; /* argument array */
+            case FP_ARG_COUNT:  pos = "NArgs";   break; /* num. arguments */
+            case FP_NAME:       pos = "FnName";  break;
+            case FP_LOCAL_SYMS: pos = "FnSyms";  break;
+            case FP_LOOP_CNT:   pos = "LoopCnt"; break;
+            case FP_OLD_LP:     pos = "OldLP";   break;
+            case FP_OLD_FP:     pos = "OldFP";   break;
+            case FP_RET_PC:     pos = "RetPC";   break;
+            case FP_PROG:       pos = "Prog";    break;
+            case FP_ARG_ARRAY:  pos = "args[]";  break; /* argument array */
             default:
-                if (offset < -FP_TO_ARGS_DIST &&
-                    offset >= -FP_TO_ARGS_DIST - nArgs)
+                if (offset > FP_DIST_TO_ARGS &&
+                    offset <= FP_DIST_TO_ARGS + nArgs)
                 {
                     sprintf(pos = buffer, STACK_DUMP_ARG_PREFIX "%d",
-                            offset + FP_TO_ARGS_DIST + nArgs + 1);
+                            FP_DIST_TO_ARGS + nArgs + 1 - offset);
                 }
                 break;
         }
